> ## Documentation Index
> Fetch the complete documentation index at: https://docs.insforge.dev/llms.txt
> Use this file to discover all available pages before exploring further.

# Update function

> Update an existing function's code or metadata



## OpenAPI

````yaml https://raw.githubusercontent.com/InsForge/InsForge/main/openapi/functions.yaml put /api/functions/{slug}
openapi: 3.0.3
info:
  title: Insforge Functions API
  version: 1.0.0
  description: Serverless functions running in Deno runtime
servers: []
security: []
paths:
  /api/functions/{slug}:
    put:
      tags:
        - Admin
      summary: Update function
      description: Update an existing function's code or metadata
      parameters:
        - name: slug
          in: path
          required: true
          schema:
            type: string
            pattern: ^[a-zA-Z0-9_-]+$
          description: Function slug identifier
          example: hello-world
      requestBody:
        required: true
        content:
          application/json:
            schema:
              type: object
              properties:
                name:
                  type: string
                  description: New display name
                code:
                  type: string
                  description: Updated function code
                description:
                  type: string
                  description: Updated description
                status:
                  type: string
                  enum:
                    - draft
                    - active
                    - error
                  description: Function status
      responses:
        '200':
          description: Function updated successfully
          content:
            application/json:
              schema:
                type: object
                properties:
                  success:
                    type: boolean
                  function:
                    $ref: '#/components/schemas/FunctionMetadata'
              example:
                success: true
                function:
                  id: 123e4567-e89b-12d3-a456-426614174000
                  slug: hello-world
                  name: Hello World Function v2
                  description: Returns a greeting message
                  status: active
                  updated_at: '2024-01-21T11:00:00Z'
        '400':
          description: Invalid request
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
        '404':
          description: Function not found
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
              example:
                error: Function not found
        '500':
          description: Failed to update function
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
      security:
        - bearerAuth: []
components:
  schemas:
    FunctionMetadata:
      type: object
      properties:
        id:
          type: string
          format: uuid
          description: Unique identifier for the function
        slug:
          type: string
          description: URL-friendly identifier
          example: hello-world
        name:
          type: string
          description: Display name for the function
          example: Hello World Function
        description:
          type: string
          nullable: true
          description: Description of what the function does
        status:
          type: string
          enum:
            - draft
            - active
            - error
          description: Current status of the function
        created_at:
          type: string
          format: date-time
          description: When the function was created
        updated_at:
          type: string
          format: date-time
          description: When the function was last updated
        deployed_at:
          type: string
          format: date-time
          nullable: true
          description: When the function was last deployed (null if never deployed)
      required:
        - id
        - slug
        - name
        - status
        - created_at
        - updated_at
    ErrorResponse:
      type: object
      properties:
        error:
          type: string
          description: Error message
        details:
          oneOf:
            - type: string
            - type: array
              items:
                type: object
            - type: object
          description: Additional error details
        message:
          type: string
          description: Detailed error message
        pattern:
          type: string
          description: >-
            Pattern that caused validation failure (for dangerous code
            detection)
  securitySchemes:
    bearerAuth:
      type: http
      scheme: bearer
      bearerFormat: JWT

````